#ifndef __COMMON_H__
#define __COMMON_H__	 

#include "sys.h"
#include "usart.h"		
#include "delay.h"	
#include "led.h"   	 	 	 	 	 	    	  	 
#include "malloc.h"
#include "string.h"   
#include "uart5.h"



#define AT_MODE_CONFIG		1				//0,ES/RSTӲƽATģʽ;
											//1,ô(+++1B1B1B)ATģʽ
//ES/RSTźſIO.
#define ES_CTRL				PAout(4)		//ES/RST
 
void ESP_01_init(void);
void ESP_01_at_response(u8 mode);
u8* ESP_01_check_cmd(u8 *str);
u8 ESP_01_send_cmd(u8 *cmd,u8 *ack,u16 waittime);
u8 ESP_01_quit_trans(void);
u8 ESP_01_wifiap_sta_test(void);
u8 ESP_01_AT_RST(u8 j);



void ESP_01_test(void);


//ûò
extern const u8* server_port;			//Ӷ˿
extern const u8* ip;
extern const u8* type;
 
extern const u8* wifista_ssid;		//WIFI STA SSID
extern const u8* wifista_encryption;//WIFI STA ܷʽ
extern const u8* wifista_password; 	//WIFI STA 

extern const u8* wifi_ssid;		//WIFI AP SSID
extern const u8* wifiap_encryption;	//WIFI AP ܷʽ
extern const u8* wifi_password; 	//WIFI AP 


#endif





