#include "delay.h" 			 
#include "usart.h" 			 
#include "uart4.h" 			 
#include "spp_ca.h" 
#include "string.h"	 
#include "math.h"
#include "common.h"

/*SPP_CAģԴ*/   								  

/********************************************************************************								  	   
*ܣͨATָSPP_CAģǷѾ									*
*ʼSPP-CAģ																*
*ֵ:0,ɹ;1,ʧ.															*					
*********************************************************************************/
u8 SPP_CA_Init(void)
{
	u8 retry=10,t;	  		 
	u8 temp=1;
	u8 reclen = 0;	
	
	UART4_Init(9600);	//ʼ4Ϊ:9600,.
	
	while(retry--)
	{
		delay_ms(10);
		u4_printf("AT\r\n");		//ATָ,鿴ǷOK
		for(t=0;t<10;t++) 			//ȴ50ms,SPP_CAģĻӦ
		{
			if(UART4_RX_STA&0X8000)break;
			delay_ms(5);
		}		
		if(UART4_RX_STA&0x8000)	//յһ
		{
			temp=UART4_RX_STA&0X7FFF;	//õݳ SPPǼȷ
				/******************************test_uart4****************************/							
					reclen=UART4_RX_STA&0X7FFF;	//õݳ
					UART4_RX_BUF[reclen]=0;	 	// 								
					printf("Connection_BT:\r\n\r\n%s",UART4_RX_BUF);//ͻӦݵ1					
				/*********************************************************************/			
			UART4_RX_STA=0;
			if(temp==5&&UART4_RX_BUF[0]=='O'&&UART4_RX_BUF[1]=='K')
			{
				temp=0;//յOKӦ
				break;
			}
		}			    		
	}		    
	if(retry==0)temp=1;	//ʧ
	return temp;	 
}	

void MCU_BT_Module(void)
{
	
	u8 t;
	u8 len;
	u8 reclen = 0;
	u16 times = 0;
	if(USART_RX_STA&0x8000)//ͨUSART1ݣPC->USART1
	{	
		len=USART_RX_STA&0x3fff;//õ˴νյݳ
		printf("\r\nSend_data1:\r\n");
		for(t=0;t<len;t++)
		{
			USART1->DR=USART_RX_BUF[t];
			while((USART1->SR&0X40)==0);//ȴͽ
		}		
		u4_printf("%s\r\n",USART_RX_BUF);//--UART4--
		
		/*ȴ500ms,SPP_CAģĻӦ*/
		for(t=0;t<100;t++) 			
		{
			if(UART4_RX_STA&0X8000)break;
			delay_ms(5);
		}		
		for(t=0;t<len;t++) USART_RX_BUF[t] = 0;//USART1UART4ȥ500msͿʼ			
		if(UART4_RX_STA&0x8000)//ͨUART4
		{
			len=UART4_RX_STA&0x3fff;//õ˴νյݳ					
			reclen=UART4_RX_STA&0X7FFF;	//õݳ
			UART4_RX_BUF[reclen]=0;	 	// 									
			printf("\r\n%s\r\n",UART4_RX_BUF);//ͻӦݵ1	
			UART4_RX_STA = 0;		
			delay_ms(500);
		}else
		{
			times++;
			if(times%200==0)
			printf("Bluetooth module data returned failure!\r\n"); 
		}
		USART_RX_STA=0;
	}else//ͨUSART1 (APP->UART4->USART1->PC)
	{ 				
		if(UART4_RX_STA&0x8000) 
		{
			printf("\r\nReceive_data:");					
			len=UART4_RX_STA&0x3fff;//õ˴νյݳ					
			reclen=UART4_RX_STA&0X7FFF;	//õݳ
			UART4_RX_BUF[reclen]=0;	 	// 				
			printf("\r\n%s\r\n",UART4_RX_BUF);//ͻӦݵ1	
			UART4_RX_STA = 0;		
		  
			delay_ms(500);
		}				
	}		

}

/*
4ʱ״̬
*/
void BT_Uart4_state(void)
{
	u8 reclen = 0;										
	reclen=UART4_RX_STA&0X7FFF;	//õݳ
	UART4_RX_BUF[reclen]=0;	 	// 				
	UART4_RX_STA = 0;
}


/*
ֻ->UART4->MCU
->PCʾ:printf();
or
->ֻʾ:u4_printf();
or
->wifiģʾESP_01_send_cmd();
or
->ʾESP_01_send_cmd();
*/
void BT_Uart(void)
{
	u8 reclen = 0;
	delay_ms(500);	
	memset(UART4_RX_BUF,0x00,sizeof(UART4_RX_BUF));	
	while(1)
	{				
		printf("\r\nPC Receive_data or connect BT:");										
		reclen=UART4_RX_STA&0X7FFF;	//õݳ
		UART4_RX_BUF[reclen]=0;	 	// 			
		printf("%s\r\n",UART4_RX_BUF);//ͻӦݵ1	
		UART4_RX_STA = 0;
		u4_printf("\r\n%s\r\n",UART4_RX_BUF);
		if (1 == ESP_01_send_cmd(UART4_RX_BUF,"OK",1000))//MCU->wifiģ
		{
			u4_printf("Wrong or no Input!\r\n");//MCU--UART4--ֻ
		}else
		{
			memset(UART4_RX_BUF,0x00,sizeof(UART4_RX_BUF));
			break;
		}
	}

}


