#include "delay.h"
#include "uart4.h"
#include "stdarg.h"	 	 
#include "stdio.h"	 	 
#include "string.h"	   

/*4,⺯汾 */

//ڷͻ 	
__align(8) u8 UART4_TX_BUF[UART4_MAX_SEND_LEN]; 	//ͻ,UART4_MAX_SEND_LENֽ
#ifdef UART4_RX_EN   								//ʹ˽   	  
//ڽջ 	
u8 UART4_RX_BUF[UART4_MAX_RECV_LEN]; 				//ջ,UART4_MAX_RECV_LENֽ.


//ͨжϽ2ַ֮ʱ10msǲһ.
//2ַռ10ms,Ϊ1.Ҳǳ10msûнյ
//κ,ʾ˴ν.
//յ״̬
//[15]:0,ûнյ;1,յһ.
//[14:0]:յݳ
u16 UART4_RX_STA=0;
/*************************************************************************/
void UART4_IRQHandler(void)
{
		u8 res;	
		if(USART_GetITStatus(UART4, USART_IT_RXNE) != RESET)//յ
		{
				res =USART_ReceiveData(UART4);//ȡյ	
				if(UART4_RX_STA<UART4_MAX_RECV_LEN)		//Խ
				{
					TIM_SetCounter(TIM4,0);//        				 
					if(UART4_RX_STA==0)TIM4_Set(1);	 	//ʹܶʱ4ж 
					UART4_RX_BUF[UART4_RX_STA++]=res;		//¼յֵ	 
				}else 
				{
					UART4_RX_STA|=1<<15;					//ǿƱǽ
				} 
		}

}

//ʼIO PC10 PC11 4 
//pclk1:PCLK1ʱƵ(Mhz)
//bound:	 
void UART4_Init(u32 bound)
{
		//GPIO˿
		GPIO_InitTypeDef GPIO_InitStructure;
		NVIC_InitTypeDef NVIC_InitStructure;
		USART_InitTypeDef UART_InitStructure;
	
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC|RCC_APB2Periph_AFIO ,ENABLE);	// GPIOCʱ
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART4,ENABLE);
		 
		USART_DeInit(UART4); //λ4 
		
		//UART4_TX  PC.10 
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10; //PC.10
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;	//
		GPIO_Init(GPIOC, &GPIO_InitStructure); //ʼPC.10
		//UART4_RX  PC.11  
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;//PC.11
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;//
		GPIO_Init(GPIOC, &GPIO_InitStructure);  //ʼPC.11
	
		UART_InitStructure.USART_BaudRate = bound;//һΪ9600;
		UART_InitStructure.USART_WordLength = USART_WordLength_8b;//ֳΪ8λݸʽ
		UART_InitStructure.USART_StopBits = USART_StopBits_1;//һֹͣλ
		UART_InitStructure.USART_Parity = USART_Parity_No;//żУλ
		UART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;//Ӳ
		UART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;	//շģʽ

	  
		USART_Init(UART4, &UART_InitStructure); //ʼ 4
		UART_DMA_Config(DMA2_Channel5,(u32)&UART4->DR,(u32)UART4_TX_BUF);//DMA2ͨ5,Ϊ2,洢ΪUSART2_TX_BUF 
		USART_Cmd(UART4, ENABLE); //ʹܴ
		
#ifdef UART4_RX_EN		  	//ʹ˽
			USART_ITConfig(UART4, USART_IT_RXNE, ENABLE);//ж	

			NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;
			NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=2 ;//ռȼ3
			NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;		//ȼ3
			NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			//IRQͨʹ
			NVIC_Init(&NVIC_InitStructure);	//ָĲʼVICĴ
			
			TIM4_Init(99,7199);		//10msж
			UART4_RX_STA=0;		//
			TIM4_Set(0);			//رնʱ4
#endif
}
/************************************************************************************
*4,printf ȷһηݲUART4_MAX_SEND_LENֽ							*
*																					*	
*************************************************************************************/
void u4_printf(char* fmt,...)  
{  
	va_list ap;
	va_start(ap,fmt);
	vsprintf((char*)UART4_TX_BUF,fmt,ap);
	va_end(ap);
	while(DMA_GetCurrDataCounter(DMA2_Channel5)!=0);	//ȴͨ3   
	UART_DMA_Enable(DMA2_Channel5,strlen((const char*)UART4_TX_BUF)); 	//ͨdmaͳȥ
}
//ʱ4жϷ		    
void TIM4_IRQHandler(void)
{ 	
	if (TIM_GetITStatus(TIM4, TIM_IT_Update) != RESET)//Ǹж
	{	 			   
		UART4_RX_STA|=1<<15;	//ǽ
		TIM_ClearITPendingBit(TIM4, TIM_IT_Update  );  //TIMxжϱ־    
		TIM4_Set(0);			//رTIM4  
	}	    
}
//TIM4Ŀ
//sta:0ر;1,;
void TIM4_Set(u8 sta)
{
	if(sta)
	{
       
		TIM_SetCounter(TIM4,0);//
		TIM_Cmd(TIM4, ENABLE);  //ʹTIMx	
	}else TIM_Cmd(TIM4, DISABLE);//رնʱ4	   
}
//ͨöʱжϳʼ
//ʼѡΪAPB12APB1Ϊ36M
//arrԶװֵ
//pscʱԤƵ		 
void TIM4_Init(u16 arr,u16 psc)
{	
	NVIC_InitTypeDef NVIC_InitStructure;
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE); //ʱʹ//TIM4ʱʹ    
	
	//ʱTIM3ʼ
	TIM_TimeBaseStructure.TIM_Period = arr; //һ¼װԶװؼĴڵֵ	
	TIM_TimeBaseStructure.TIM_Prescaler =psc; //ΪTIMxʱƵʳԤƵֵ
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //ʱӷָ:TDTS = Tck_tim
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
	TIM_TimeBaseInit(TIM4, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ
 
	TIM_ITConfig(TIM4,TIM_IT_Update,ENABLE ); //ʹָTIM4ж,ж

	 	  
	NVIC_InitStructure.NVIC_IRQChannel = TIM4_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1 ;//ռȼ3
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;		//ȼ3
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			//IRQͨʹ
	NVIC_Init(&NVIC_InitStructure);	//ָĲʼVICĴ
	
}
#endif

///////////////////////////////////////USART2 DMAò//////////////////////////////////	   		    
//DMA2ĸͨ
//Ĵʽǹ̶,Ҫݲͬ޸
//Ӵ洢->ģʽ/8λݿ/洢ģʽ
//DMA_CHx:DMAͨCHx
//cpar:ַ
//cmar:洢ַ    
void UART_DMA_Config(DMA_Channel_TypeDef*DMA_CHx,u32 cpar,u32 cmar)
{
	DMA_InitTypeDef DMA_InitStructure;
 	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA2, ENABLE);	//ʹDMA2
  DMA_DeInit(DMA_CHx);   //DMAͨ2ĴΪȱʡֵ
	DMA_InitStructure.DMA_PeripheralBaseAddr = cpar;  //DMAADCַ
	DMA_InitStructure.DMA_MemoryBaseAddr = cmar;  //DMAڴַ
	DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;  //ݴ䷽򣬴ڴȡ͵
	DMA_InitStructure.DMA_BufferSize = 0;  //DMAͨDMAĴС
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;  //ַĴ
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;  //ڴַĴ
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;  //ݿΪ8λ
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte; //ݿΪ8λ
	DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;  //ģʽ
	DMA_InitStructure.DMA_Priority = DMA_Priority_Medium; //DMAͨ xӵȼ 
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;  //DMAͨxûΪڴ浽ڴ洫
	DMA_Init(DMA_CHx, &DMA_InitStructure);  //DMA_InitStructָĲʼDMAͨUSART1_Tx_DMA_ChannelʶļĴ	
} 
//һDMA
void UART_DMA_Enable(DMA_Channel_TypeDef*DMA_CHx,u8 len)
{	
	USART_DMACmd(UART4, USART_DMAReq_Tx, ENABLE);//UART4ģóDMAʽ
	DMA_Cmd(DMA_CHx, DISABLE );  //رָʾͨ        
	DMA_SetCurrDataCounter(DMA_CHx,len);//DMAͨDMAĴС	
	DMA_Cmd(DMA_CHx, ENABLE);           //DMA
}	   
