/*-------------------------------------------------------------------------

							

    
-------------------------------------------------------------------------*/
#include "includes.h"


extern	OS_TCB	taskStartTCB;						//ջ

static OS_TCB LED12_TCB;
static CPU_STK LED12_stk[LED12_STK_SIZE];

static OS_TCB BT_TCB;
static CPU_STK BT_stk[BT_STK_SIZE];

static OS_TCB task3TCB;
static CPU_STK task3_stk[TASK3_STK_SIZE];

static volatile OS_SEM Usart1_Sem;
static volatile OS_SEM LED12_Sem;
/*******************************************************************************
* Function Name :void TaskStart(void)
* Description   :
* Input         :
* Output        :
* Other         :
* Date          :2015.06.16  
*******************************************************************************/
void TaskStart(void)
{
    OS_ERR 		err;
    SysTickInit();
	

    OSTaskCreate(   (OS_TCB     *)&LED12_TCB,
                    (CPU_CHAR   *)"LED12",
                    (OS_TASK_PTR)LED12,
                    (void       *)0,
                    (OS_PRIO    )LED12_PRIO,
                    (CPU_STK    *)&LED12_stk[0],
                    (CPU_STK_SIZE)LED12_STK_SIZE / 10,
                    (CPU_STK_SIZE)LED12_STK_SIZE,
                    (OS_MSG_QTY )0,
                    (OS_TICK    )0,
                    (void       *)0,
                    (OS_OPT     )(OS_OPT_TASK_STK_CHK | OS_OPT_TASK_STK_CLR), 
                    (OS_ERR     *)&err);
    
    OSTaskCreate(   (OS_TCB     *)&BT_TCB,
                    (CPU_CHAR   *)"BT",
                    (OS_TASK_PTR)BT,
                    (void       *)0,
                    (OS_PRIO    ) BT_PRIO,
                    (CPU_STK    *)&BT_stk[0],
                    (CPU_STK_SIZE)BT_STK_SIZE / 10,
                    (CPU_STK_SIZE)BT_STK_SIZE,
                    (OS_MSG_QTY )0,
                    (OS_TICK    )0,
                    (void       *)0,
                    (OS_OPT     )(OS_OPT_TASK_STK_CHK | OS_OPT_TASK_STK_CLR), 
                    (OS_ERR     *)&err);	
    
    
//    OSTaskCreate(   (OS_TCB     *)&task3TCB,
//                    (CPU_CHAR   *)"Task3",
//                    (OS_TASK_PTR)Task3,
//                    (void       *)0,
//                    (OS_PRIO    )TASK3_PRIO,
//                    (CPU_STK    *)&task3_stk[0],
//                    (CPU_STK_SIZE)TASK3_STK_SIZE / 10,
//                    (CPU_STK_SIZE)TASK3_STK_SIZE,
//                    (OS_MSG_QTY )0,
//                    (OS_TICK    )0,
//                    (void       *)0,
//                    (OS_OPT     )(OS_OPT_TASK_STK_CHK | OS_OPT_TASK_STK_CLR), 
//                    (OS_ERR     *)&err);
    
    /*1ź*/
    OSSemCreate(    (OS_SEM     *)&Usart1_Sem, 
                    (CPU_CHAR   *)"Usart1_Sem", 
                    (OS_SEM_CTR )0, 
                    (OS_ERR     *)err);
	/*4ź*/
	
	/*5ź*/

	/*LED1+LED2ź*/
	OSSemCreate(    (OS_SEM     *)&LED12_Sem, 
                    (CPU_CHAR   *)"LED12_Sem", 
                    (OS_SEM_CTR )0, 
                    (OS_ERR     *)err);
					
	/*Check "err"*/				
//	if (OS_ERR_NONE != err)
//	{
//		return ;
//	}
    /*˯״̬*/
    OSTaskDel(      (OS_TCB     *)&taskStartTCB, 
                    (OS_ERR     *)&err);
					
}

void LED12(void *p_arg)
{
    OS_ERR err;
    
    while (1)
    {
//        OSSemPend(  (OS_SEM     *)&LED12_Sem, 
//                    (OS_TICK    )100, 
//                    (OS_OPT     )OS_OPT_PEND_BLOCKING, 
//                    (CPU_TS     *)0, 
//                    (OS_ERR     *)&err);   
		GPIO_SetBits(GPIOB,  GPIO_Pin_6 | GPIO_Pin_7);//øIO,صָʾ D1&D2
        OSTimeDly(  (OS_TICK    )200, 
                    (OS_OPT     )OS_OPT_TIME_DLY, 
                    (OS_ERR     *)&err);		
		GPIO_ResetBits(GPIOB,  GPIO_Pin_6 | GPIO_Pin_7);//õioڣָʾ1 2
        OSTimeDly(  (OS_TICK    )100, 
                    (OS_OPT     )OS_OPT_TIME_DLY, 
                    (OS_ERR     *)&err);
		/*LED12Ƶź*/
		OSSemPost(  (OS_SEM     *)&LED12_Sem, 
                    (OS_OPT     )OS_OPT_POST_ALL, 
                    (OS_ERR     *)&err);
    }
}

void BT(void *p_arg)
{
    OS_ERR err;

    while (1)
    {
        OSSemPend(  (OS_SEM     *)&LED12_Sem, 
                    (OS_TICK    )1000, 
                    (OS_OPT     )OS_OPT_PEND_BLOCKING, 
                    (CPU_TS     *)0, 
                    (OS_ERR     *)&err);   
		GPIO_SetBits(GPIOB,  GPIO_Pin_6 | GPIO_Pin_7);//øIO,صָʾ D1&D2
		MCU_BT_Module();//ģ		
		GPIO_ResetBits(GPIOB, GPIO_Pin_7);//õioڣָʾ1	
		OSTimeDly(  (OS_TICK    )10000, 
                    (OS_OPT     )OS_OPT_TIME_DLY, 
                    (OS_ERR     *)&err);
		GPIO_SetBits(GPIOB,   GPIO_Pin_7);	
    }
}

//void Task3(void *p_arg)
//{
//    OS_ERR err;
//    
//    while (1)
//    {
//        OSSemPend(  (OS_SEM     *)&LED12_Sem, 
//                    (OS_TICK    )100, 
//                    (OS_OPT     )OS_OPT_PEND_BLOCKING, 
//                    (CPU_TS     *)0, 
//                    (OS_ERR     *)&err);   
//		//printf("Task3.0\n");
//		GPIO_SetBits(GPIOB,  GPIO_Pin_6 | GPIO_Pin_7);//øIO,صָʾ D1&D2	
//		GPIO_ResetBits(GPIOB, GPIO_Pin_6);//õioڣָʾ2
//		OSTimeDly(  (OS_TICK    )500, 
//                    (OS_OPT     )OS_OPT_TIME_DLY, 
//                    (OS_ERR     *)&err);
//		GPIO_SetBits(GPIOB,   GPIO_Pin_6);
//		
//		
//		OSSemPost(  (OS_SEM     *)&LED12_Sem, 
//                    (OS_OPT     )OS_OPT_POST_ALL, 
//                    (OS_ERR     *)&err);
//        OSTimeDly(  (OS_TICK    )100, 
//                    (OS_OPT     )OS_OPT_TIME_DLY, 
//                    (OS_ERR     *)&err);
//    }
//}







