/* Includes ------------------------------------------------------------------*/
#include "includes.h"

//#include "stm32f10x.h"
#include "delay.h"
#include "sys.h"
#include "usart.h"
#include "uart4.h"
#include "uart5.h"
#include "led.h"
#include "spp_ca.h"
#include "WIFI.h"
#include "string.h"
#include "common.h" 
/*------------------------------------------------------------------------------------------*/

OS_TCB taskStartTCB;								//ƿ
CPU_STK taskStartStk[STARTUP_TASK_STK_SIZE]; 		//ĳռ(ջ)


u32 i=0;     // ʱ

int main(void)
{	
	OS_ERR err;
	//BSP_Init();			//弶ʼʱ
	
	SystemInit();  //ϵͳʱúͨͬĶ ѡͬƵ 72m 
	NVIC_Configuration();// жȼ
	uart_init(9600);	 //ڳʼΪ9600
	
	LED_Init();		 //ʼLEDӵӲӿ 
 	delay_init();	 //ʱʼ	
	while (SPP_CA_Init());//ʼģ,жSTM32Ƿ 

   

	
	
    CPU_Init();
    OSInit(         (OS_ERR	    *)&err);//ϵͳʼ
	/*ʼ*/
    OSTaskCreate(   (OS_TCB     *)&taskStartTCB,				//ƿָ
                    (CPU_CHAR   *)"Task Start",					//
                    (OS_TASK_PTR)TaskStart,						//ָ
                    (void       *)0,							//ݸĲparg
                    (OS_PRIO    ) STARTUP_TASK_PRIO,			//ȼ
                    (CPU_STK    *)&taskStartStk[0],				//ջַ
                    (CPU_STK_SIZE)STARTUP_TASK_STK_SIZE / 10,	//ջʣྯ
                    (CPU_STK_SIZE)STARTUP_TASK_STK_SIZE,		//ջС
                    (OS_MSG_QTY )0,								//ɽյϢ
                    (OS_TICK    )0,								//ʱƬתʱ
                    (void       *)0,							//ƿչϢ
                    (OS_OPT     )(OS_OPT_TASK_STK_CHK | OS_OPT_TASK_STK_CLR), //ѡ
                    (OS_ERR     *)&err);   						//ֵ 
									   
    OSStart(        (OS_ERR	    *)&err);						//ʼ
}
